@function hexToRGB($hex) {
    @return red($hex), green($hex), blue($hex);
}

%button {
    font-size: inherit;
    border: 1px solid;
    border-radius: $border-radius;
    cursor: pointer;
    color: var(--color-button);
    background-color: var(--color-button-background);
    border-color: var(--color-button-border);
    white-space: nowrap;

    @include padding(2, 6);
    @include margin(0, 2);

    &.icon-button {
        // только иконка без label
        @include padding(2, 2);
        display: inline-flex;
        align-items: center;
    }

    &.with-icon {
        display: inline-flex;
        vertical-align: middle;
        align-items: center;
        justify-content: space-evenly;
        flex-wrap: nowrap;
    }

    .icon--left {
        vertical-align: middle;
        @include marginRight(2);
    }

    .icon--right {
        vertical-align: middle;
        @include marginLeft(2);
    }

    .icon--loading {
        @include margin(0, 2);
    }

    &:hover:not([disabled]):not(.loading) {
        color: var(--color-button-hover);
        background-color: var(--color-button-background-hover);
        border-color: var(--color-button-border-hover);
    }

    &:active:not([disabled]){
        color: var(--color-button-active);
        background-color: var(--color-button-background-active);
        border-color: var(--color-button-border-active);
    }

    &.large {
        font-size: $font-size-xlarge;
        @include padding(3, 8);
    }

    &.small {
        font-size: $font-size-small;
        @include padding(1, 4);
    }

    &.xsmall {
        font-size: $font-size-xsmall;
        @include padding(1, 3);
    }

    &[disabled] {
        cursor: not-allowed;
        text-decoration: none;
        color: var(--color-button-disabled);
        background-color: var(--color-button-background-disabled);
        border-color: var(--color-button-border-disabled);
    }

    &.loading {
        cursor: wait;
    }

    &.outlined {
        --color-button-background-hover: #FFFFFF;
        --color-button-background-disabled: #{$grey-100};

        color: var(--color-button-border);
        background-color: #FFFFFF;

        &:hover:not([disabled]) {
            color: var(--color-button-border-hover);
            background-color: var(--color-button-background-hover);
            border-color: var(--color-button-border-hover);
        }

        &:active:not([disabled]) {
            color: var(--color-button-border-active);
            background-color: rgba(var(--color-button-background-active-rgb), 0.3);
            border-color: var(--color-button-border-active);
        }

        &[disabled] {
            color: var(--color-button-border-disabled);
            background-color: var(--color-button-background-disabled);
            border-color: var(--color-button-border-disabled);
        }
    }
}

// colors
.default,
.red {
    --color-button: #FFFFFF;
    --color-button-background: #{$red-500};
    --color-button-border: #{$red-500};

    --color-button-hover: #FFFFFF;
    --color-button-background-hover: #{$red-400};
    --color-button-border-hover: #{$red-400};

    --color-button-active: #FFFFFF;
    --color-button-background-active: #{$red-600};
    --color-button-background-active-rgb: #{red($red-600)}, #{green($red-600)}, #{blue($red-600)};
    --color-button-border-active: #{$red-600};

    --color-button-disabled: #FFFFFF;
    --color-button-background-disabled: #{$grey-400};
    --color-button-border-disabled: #{$grey-400};

    @extend %button;
}

.dark {
    --color-button: #FFFFFF;
    --color-button-background: #{$dark-900};
    --color-button-border: #{$dark-900};

    --color-button-hover: #FFFFFF;
    --color-button-background-hover: #{$violet-800};
    --color-button-border-hover: #{$violet-800};

    --color-button-active: #FFFFFF;
    --color-button-background-active: #{$dark-800};
    --color-button-background-active-rgb: #{red($dark-800)}, #{green($dark-800)}, #{blue($dark-800)};
    --color-button-border-active: #{$dark-800};

    @extend %button;
}

.white {
    --color-button: #{$dark-900};
    --color-button-background: #FFFFFF;
    --color-button-border: #FFFFFF;

    --color-button-hover: #{$violet-800};
    --color-button-background-hover: #{$grey-100};
    --color-button-border-hover: #{$grey-100};

    --color-button-active: #{$dark-800};
    --color-button-background-active: #{$dark-800};
    --color-button-background-active-rgb: #{red($dark-800)}, #{green($dark-800)}, #{blue($dark-800)};
    --color-button-border-active: #{$dark-800};

    @extend %button;
}
